<?php

namespace App\Models;

use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name',
        'email',
        'password',
        'photo',
        'ext_id',
        'active',
        'dep',
        'position',
        'arrow',
        'rate',
    ];
    protected $appends = ['images', 'warehouse'];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password',
    ];

    public function getImagesAttribute()
    {
        $dep = $this->dep;
        switch ($dep) {
            case 'new':
                $dep = "newcars";
                break;
        }
        return [
            "/images/workers/" . str_slug($this->name) . '.png',
            "images/workers/" . str_slug($this->name) . '_220x265.png',
            "/images/workers/" . str_slug($this->name) . '_375x440.png',
        ];
    }

    public function p_fields()
    {
        $m = (int) date('m');
        $y = (int) date('Y');
        $m = $m === 1 ? 12 : $m - 1;
        $y = $m === 1 ? $y - 1 : $y;

        return $this->hasOne(Fields::class)
            ->where('month', $m)
            ->where('year', $y);
    }

    public function fields()
    {
        return $this->hasOne(Fields::class)
            ->where('month', (int) date('m'))
            ->where('year', (int) date('Y'));
    }

    public function all_fields()
    {
        return $this->hasMany(Fields::class);
    }

    public function year_fields()
    {
        return $this->all_fields()->where('year', (int) date('Y'));
    }

    public function __get($key)
    {
        //        $this->fields()->firstOrCreate();
        return parent::__get($key); // TODO: Change the autogenerated stub
    }

    public function delete()
    {
        $this->fields()->delete();
        return parent::delete();
    }


    public function getWarehouseAttribute()
    {
        if ($this->dep == 'new' || $this->dep == 'new_add') {
            return "000000002";
        }
        if ($this->dep == 'bu') {
            return "000000030";
        }

        return null;
    }

    public static function getUserId($name){

        return User::where('name', $name)->value('id');
    }
}
